
extern "C" 
{
#include "lua.h"
#include "lauxlib.h"
#include "lualib.h"
}

#include <iostream>

int main()
{
	std::cout << "Loading and running \"helloWorld\" function from \"test.lua\"\n";

	int iErr = 0;
	lua_State *L = lua_open();

    luaopen_io(L); // provides io.*
    luaopen_base(L);
    luaopen_table(L);
    luaopen_string(L);
    luaopen_math(L);
    luaopen_loadlib(L);

	if((iErr = luaL_loadfile(L, "test.lua")) == 0)
	{

		if ((iErr = lua_pcall (L, 0, LUA_MULTRET, 0)) == 0)
		{
			lua_pushstring (L, "helloWorld");

			lua_gettable (L, LUA_GLOBALSINDEX);
			lua_pcall (L, 0, 0, 0);
		}
		else
			std::cout << "Error calling function.\n";

	}
	else
		std::cout << "Error opening file.\n";
	
	lua_close(L);

	std::cout << "Done.\n";
	std::cin.get();

	return 0;
}